#ifndef Py_CONFIG_H
#define Py_CONFIG_H

/* config.h. Edited by hand for Amiga SAS/C by Irmen de Jong, 10 nov. 1995 */
/* (adapted from: config.h.in) */
/* NOTE: all useless stuff (for Amiga) has been removed */

/* 27-mar-96: updated for AmiTCP (Irmen de Jong) */
/*  8-dec-96: now for Python 1.4 */

#define HAVE_PROTOTYPES
#define HAVE_STDARG_PROTOTYPES
#define HAVE_TZNAME
#define RETSIGTYPE void
#define STDC_HEADERS
#define HAVE_LSTAT
#define HAVE_LINK
#define HAVE_PUTENV
#define HAVE_CLOCK
#define HAVE_SETVBUF
#define HAVE_STRFTIME
#define HAVE_DIRENT_H
#define HAVE_FCNTL_H
#define HAVE_LIMITS_H
#define HAVE_SIGNAL_H
#define HAVE_STDARG_H
#define HAVE_STDDEF_H
#define HAVE_STDLIB_H
#define HAVE_SYS_DIR_H
#define HAVE_UNISTD_H
#define DONT_HAVE_SIG_ALARM
#define DONT_HAVE_SIG_PAUSE
#define HAVE_CONFIG_H
#define HAVE_LSTAT
#define HAVE_PROTOTYPES
#define HAVE_GETCWD
#define HAVE_DIRENT_H
#define HAVE_UNISTD_H
#define HAVE_SYS_DIR_H
#define HAVE_SIGNAL_H
#define HAVE_STDLIB_H

/* Define if a va_list is an array of some kind */
#undef VA_LIST_IS_ARRAY

#undef HAVE_GETPPID
#undef HAVE_KILL
#undef HAVE_FCNTL

/*  BUILTIN LIBRARY SEARCH PATH */
#define PYTHONPATH "Python:Lib"


/* Define if you have the getpid function.  */
#define HAVE_GETPID


#ifdef AMITCP
/*
** AmiTCP makes a lot more functions available!
*/

/* Define if you can safely include both <sys/time.h> and <time.h>.  */
#define TIME_WITH_SYS_TIME

/* Define if your <sys/time.h> declares struct tm.  */
#undef TM_IN_SYS_TIME

/* Define if getpgrp() must be called as getpgrp(0). */
#undef GETPGRP_HAVE_ARG

/* Define if you have the chown function.  */
#define HAVE_CHOWN

/* Define if you have the dlopen function.  */
#undef HAVE_DLOPEN

/* Define if you have the ftime function.  */
#undef HAVE_FTIME

/* Define if you have the ftruncate function.  */
#undef HAVE_FTRUNCATE
/* int ftruncate(int fd, long newlength);	implemented in python_net.lib */
/* BUGGY when EXTENDING the file */

/* Define if you have the gethostname_r function.  */
#undef HAVE_GETHOSTNAME_R

/* Define if you have the getpgrp function.  */
#define HAVE_GETPGRP

/* Define if you have the gettimeofday function.  */
#define HAVE_GETTIMEOFDAY

/* Define if you have the setgid function.  */
#define HAVE_SETGID

/* Define if you have the setpgid function.  */
#undef HAVE_SETPGID

/* Define if you have the setpgrp function.  */
#undef HAVE_SETPGRP

/* Define if you have the setsid function.  */
#define HAVE_SETSID

/* Define if you have the setuid function.  */
#define HAVE_SETUID

/* Define if you have the tcgetpgrp function.  */
#undef HAVE_TCGETPGRP

/* Define if you have the tcsetpgrp function.  */
#undef HAVE_TCSETPGRP

/* Define if you have the <sys/param.h> header file.  */
#define HAVE_SYS_PARAM_H

/* Define if you have the <sys/select.h> header file.  */
#undef HAVE_SYS_SELECT_H

/* Define if you have the <sys/time.h> header file.  */
#define HAVE_SYS_TIME_H

/* Define if you have the <utime.h> header file.  */
#define HAVE_UTIME_H

#define HAVE_GETEGID
#define HAVE_GETEUID
#define HAVE_GETGID
#define HAVE_GETUID

/*
** Extra AmiTCP networking functions (getpeername, select)
*/

/* Define if you have the getpeername function.  */
#define HAVE_GETPEERNAME

/* Define if you have the select function.  */
#define HAVE_SELECT

/* Define if you have the <sys/select.h> header file.  */
#undef HAVE_SYS_SELECT_H

#endif


#ifndef AMITCP
/* compiling without AmiTCP, thus without net includes. */

#undef HAVE_GETEGID
#undef HAVE_GETEUID
#undef HAVE_GETGID
#undef HAVE_GETUID

#undef TIME_WITH_SYS_TIME
#undef TM_IN_SYS_TIME
#undef GETPGRP_HAVE_ARG
#undef HAVE_CHOWN
#undef HAVE_DLOPEN
#undef HAVE_FTIME
#undef HAVE_FTRUNCATE
#undef HAVE_GETHOSTNAME_R
#undef HAVE_GETPEERNAME
#undef HAVE_GETPGRP
#undef HAVE_GETTIMEOFDAY
#undef HAVE_SELECT
#undef HAVE_SETGID
#undef HAVE_SETPGID
#undef HAVE_SETPGRP
#undef HAVE_SETSID
#undef HAVE_SETUID
#undef HAVE_TCGETPGRP
#undef HAVE_TCSETPGRP
#undef HAVE_SYS_PARAM_H
#undef HAVE_SYS_SELECT_H
#undef HAVE_SYS_TIME_H
#undef HAVE_UTIME_H

#endif



/**********************************************************************
** The following things can be implemented with a little bit of work:
** (maybe I'll do this in the near future? who knows.. I.J.)
*/

/* Define if you have the readlink function.  */
#undef HAVE_READLINK		/* implemented inline in amigamodule.c */

/* Define if you have the symlink function.  */
#undef HAVE_SYMLINK			/* implemented inline in amigamodule.c */

/* Define if you have the truncate function.  */
#undef HAVE_TRUNCATE

/* Define if you have the uname function.  */
#undef HAVE_UNAME

/* Define if you want to compile in rudimentary thread support */
#undef WITH_THREAD

/* Must be defined if using UNSIGNED CHARACTERS: */
/* (_UNSCHAR is SAS/C's defined symbol if using unsigned chars) */

#ifdef _UNSCHAR
#define __UNSIGNED_CHAR__
#define __CHAR_UNSIGNED__
#endif

#endif
