#ifndef SYS_INCLUDE_H
#define SYS_INCLUDE_H

#include <exec/types.h>
#include <exec/memory.h>
#include <intuition/screens.h>
#include <intuition/intuition.h>
#include <libraries/iffparse.h>
#include <dos/dosextens.h>
#include <devices/timer.h>

#include <clib/exec_protos.h>
#include <clib/dos_protos.h>

#include <string.h>

#ifdef __GNUC__
   #include <inline/intuition.h>
   #include <inline/graphics.h>
#else
   #include <clib/graphics_protos.h>
   #include <clib/intuition_protos.h>
#endif

#ifdef LATTICE
extern struct Library *DOSBase;
   #include <pragmas/dos_pragmas.h>
   #include <pragmas/exec_pragmas.h>
   #include <pragmas/graphics_pragmas.h>
   #include <pragmas/intuition_pragmas.h>
#endif

#endif /* SYS_INCLUDE_H */
