/*
   Use this file to create a Master GST of all the non-conflicting headers
   in Include:.  The following compiler command will create the most often
   used version of the Master GST

        sc noobjname mgst=include:all.gst all.c

   Remember that you may need to make new GST's depending on your compiler
   switches used in a project.  Some switches affect the GST as well as
   your code.  For instance, if you use the UNSIGNEDCHAR switch, you will
   need to build a GST specifically for use with this model

        sc noobjname uchar mgst=include:all_u.gst all.c
*/

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <fcntl.h>
#include <limits.h>

#include <exec/types.h>

#include <devices/audio.h>
#include <devices/input.h>
#include <devices/inputevent.h>
#include <devices/printer.h>
#include <devices/timer.h>
#include <devices/trackdisk.h>

#include <diskfont/diskfont.h>
#include <diskfont/diskfonttag.h>

#include <dos/dos.h>
#include <dos/dosextens.h>
#include <dos/dosasl.h>
#include <dos/doshunks.h>
#include <dos/dostags.h>
#include <dos/rdargs.h>

#include <exec/exec.h>

#include <graphics/gfx.h>
#include <graphics/gfxmacros.h>
#include <graphics/display.h>
#include <graphics/displayinfo.h>
#include <graphics/GfxBase.h>
#include <graphics/gels.h>
#include <graphics/rastport.h>
#include <graphics/view.h>

#include <intuition/intuition.h>
#include <intuition/cghooks.h>
#include <intuition/classes.h>
#include <intuition/classusr.h>
#include <intuition/gadgetclass.h>
#include <intuition/icclass.h>
#include <intuition/imageclass.h>
#include <intuition/screens.h>
#include <intuition/sghooks.h>

#include <libraries/amigaguide.h>
#include <libraries/asl.h>
#include <libraries/gadtools.h>
#include <libraries/locale.h>
//#include <libraries/mui.h>
#include <libraries/iffparse.h>

#include <utility/date.h>
#include <utility/hooks.h>
#include <utility/name.h>
#include <utility/pack.h>
#include <utility/tagitem.h>
#include <utility/utility.h>

#include <workbench/icon.h>
#include <workbench/startup.h>
#include <workbench/workbench.h>

#include <rtgmaster/rtgmaster.h>
#include <rtgmaster/rtgsublibs.h>

#include <clib/exec_protos.h>
#include <pragmas/exec_pragmas.h>

#include <clib/intuition_protos.h>
#include <pragmas/intuition_pragmas.h>

#include <clib/dos_protos.h>
#include <pragmas/dos_pragmas.h>

#include <clib/graphics_protos.h>
#include <pragmas/graphics_pragmas.h>

#include <clib/rtgmaster_protos.h>
#include <pragmas/rtgmaster_pragmas.h>

//#include <clib/muimaster_protos.h>
//#include <pragmas/muimaster_pragmas.h>

#include <clib/asl_protos.h>
#include <pragmas/asl_pragmas.h>

#include <clib/gadtools_protos.h>
#include <pragmas/gadtools_pragmas.h>

#include <clib/locale_protos.h>
#include <pragmas/locale_pragmas.h>

#include <clib/wb_protos.h>
#include <pragmas/wb_pragmas.h>

#include <clib/utility_protos.h>
#include <pragmas/utility_pragmas.h>

#include <clib/alib_protos.h>
